//+------------------------------------------------------------------+
//|                                                 iK_ex_LinReg.mq4 |
//|                                                      Ivan Katsko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ivan Katsko"
#property link      "ICQ:372739628"
//--------------------------------------------------------------- 1 --
#define NONE 0

extern string S3="   .  ";
extern double t0=2.618;
extern string S4="   Close,\n  false - High/Low";
extern int StartT=5;
extern int FinishT=23;
extern int useCl=1;
extern int Rev=1;
extern datetime StartDateTime = D'01.01.2010';  // 
extern datetime FinishDateTime = D'31.12.2010'; // 
extern double Lots   = 1;            //   .  ("0" -   )
extern double Prots  = 0.07;         //   
extern int SlipPage     = 3;         //   -  
 
bool 
     useClose,
     LookInd=true,
     Msg=true,
     New_Bar=false,                  //    
     Cls=false,                      //   
     Work=true,                      //   .
     First=false,                    //   
     Second=false,                   //   
     Reverse=false,                  //    
     Opn_B=false,                    //     Buy
     Opn_S=false;                    //     Sell

string Symb,                         //  . 
       StartTime,
       FinishTime,
       FinTim;
       
int StPos;

static datetime New_Time;


double dirOpen       = NONE,         //   : ">0" - ; "<0" - 
       Up, Dn,                       //  /
       Profit,
       RevUp, RevDn, RevTP, RevSL;
       

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   Fun_New_Bar();                      //    
//----
   int
      Total,                           //     
      Tip=-1,                          //  .  (B=0,S=1)
      Ticket;                          //  
   double
      Lot,                             // .    
      Lts,                             // .    
      Min_Lot,                         //   
      Step,                            //    
      Free,                            //   
      One_Lot,                         //   
      SL,                              // SL   
      TP;                              // TP  
   bool
      Ans  =false;                     //    
      
   Cls  =false;                        //   
   
//-------------------      --
   if (New_Bar)                        //      
     {
      // .
      if(TimeCurrent()<StartDateTime)            //    
        { 
        Alert("   .   .",": ",Symb,", ",Period());
        return;                                  //   start()
        }            
      if (TimeCurrent()>=FinishDateTime)         //  
        { 
        Alert("  .   .",": ",Symb,", ",Period());
        return;                                  //   start()
        }            
      if(Work==false)                            //  
        {
         Alert(" .   .",": ",Symb,", ",Period());
         return;                                 //   start()
        }
     }
   
//-----------------------  
   Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                             //   start()
           }
         Ticket =OrderTicket();                 //  . .
         Tip    =OrderType();                   //   .
         SL     =OrderStopLoss();               // SL  .
         TP     =OrderTakeProfit();             // TP  .
         Profit =OrderProfit();                 // Profit  .
         Lot    =OrderLots();                   //  
        }
     }
   if(Total==0 && StartTime!="00:00" 
      && (TimeCurrent()<StrToTime(TimeToStr(CurTime(), TIME_DATE)+" "+StartTime) 
         || TimeCurrent()>StrToTime(TimeToStr(CurTime(), TIME_DATE)+" "+FinishTime)))
     return;                                  //   start()
   if(Total==0 && !First && TimeCurrent()==StrToTime(TimeToStr(CurTime(), TIME_DATE)+" "+StartTime))
       {
       First=true;
       Second=false;
       }
   if(TimeCurrent()==StrToTime(TimeToStr(CurTime(), TIME_DATE)+" "+FinishTime))
     {
     Second=false;
     LookInd=true;
     }
     
   if(!LookInd) return;
   
   if(Total==0)                                 //    
     {
     Cls=false;                                 //   
     ObjectDelete("New_Open");                  //  
     ObjectDelete("New_SL"); 
     }
   if(Total==0 && LookInd && TimeCurrent()==StrToTime(TimeToStr(CurTime(), TIME_DATE)+" "+StartTime))
     if(iCustom(0, 0, "iK_Dserg-LinReg","",t0,"",useClose,FinishTime,StartTime,0, 0)==0 &&
        iCustom(0, 0, "iK_Dserg-LinReg","",t0,"",useClose,FinishTime,StartTime,3, 0)==0)
       LookInd=false;
   
//----  
   if(Total==0 && !Second)
     {
     SL = iCustom(0, 0, "iK_Dserg-LinReg","",t0,"",useClose,FinishTime,StartTime,2, 0);
     Up = iCustom(0, 0, "iK_Dserg-LinReg","",t0,"",useClose,FinishTime,StartTime,5, 0);
     Dn = iCustom(0, 0, "iK_Dserg-LinReg","",t0,"",useClose,FinishTime,StartTime,6, 0);
     TP = iCustom(0, 0, "iK_Dserg-LinReg","",t0,"",useClose,FinishTime,StartTime,7, 0);
     RevSL=SL;
     RevTP=TP;
     RevUp=Up;
     RevDn=Dn;
     }

   if(Up==0 && Dn==0)
     return;                                  //   start()

//---- 
   if(Second && Total==0)
     {
     if(RevUp>0)
       if(Profit>0)
         {
         TP=RevUp;
         SL=RevTP+RevUp-RevSL;
         Up=RevDn;
         Dn=RevUp;
         }
         else
         {
         TP=/*RevSL+*/RevTP/*-RevUp*/;
         SL=2*RevSL-RevUp;
         Up=RevUp;
         Dn=RevDn;
         }
     if(RevDn>0)
       if(Profit>0)
         {
         TP=RevDn;
         SL=RevTP+RevDn-RevSL;
         Up=RevDn;
         Dn=RevUp;
         }
         else
         {
         TP=/*RevSL-*/(/*RevDn-*/RevTP);
         SL=2*RevSL-RevDn;
         Up=RevUp;
         Dn=RevDn;
         }
     }
//---- 
   if(Reverse && Total==0)                                    //   ,
     if(Up>0 || Dn>0)
       {
       if(Second)
         {
         LookInd=false;
         Second=false;
         }
       if(First)
         {
         First=false;
         Second=true;
         }
       }

//----   
   if(Total==0)                                    //   ,
     {
     Opn_B=false;
     Opn_S=false;
     if(Up>0)
       Opn_B=true;                               //     Buy
     if(Dn>0)
       Opn_S=true;                               //  Sell
     }

//----         
   if((Tip==0                                     //    
       && Ask>=TP)    
      ||                                          // 
       (Tip==1                                    //    
       && Bid<=TP && Bid>0))    
     {                                           
     Cls = true;                                  //   
     }

//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   
 
   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  
 
   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   
   if (Lts*One_Lot > Free &&                    //   .
      TimeCurrent()<(Time[0] + 2*60) &&         //     2- 
      Total==0)                                 //    
     {
      Alert("     ", Lts," ",": ",Symb,", ",Period());
      return;                                   //   start()
     }

//--------------------------------------------------------------- 6 --
   //  
   while(Ticket>0)                              //   .
     {
      if(Tip==0 && Cls==true)                  //   Buy..
        {                                       //    
        Alert("  Buy: ",Symb,", ",Period());
        RefreshRates();                        //  
        Ans=OrderClose(Ticket,Lot,Bid,2,Blue);      //  Buy
        if(Ans==true)                         //  :)
          break;                              //    
        if(Fun_Error(GetLastError())==1)      //  
          {
          continue;                           //  
          }
        return;                                //   start()
        }
      if(Tip==1 && Cls==true)                  //   Sell..
        {                                       //    
        Alert("  Sell: ",Symb,", ",Period());
        RefreshRates();                        //  
        Ans=OrderClose(Ticket,Lot,Ask,2,Red);      //  Sell
        if(Ans==true)                         //  :)
          break;                              //    
        if(Fun_Error(GetLastError())==1)      //  
          {
          continue;                           //  
          }
        return;                                //   start()
        }
      break;                                    //   while
     }
 
//----  
   while(Total==0)                                 //   .
     {
      if(Opn_B==true)              //  .  +
        {                                       //  . Buy
        RefreshRates();                        //  
        Alert("  Buy: ",Symb,", ",Period());
        Alert("Ask=",Ask," SL=",SL," TP=",TP);
        Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP,0,0,0,Blue);// Buy
        if(Ticket > 0)                        //  :)
          {
          return;                             //   start()
          }
        if(Fun_Error(GetLastError())==1)      //  
          continue;                           //  
        return;                                //   start()
        }
      if(Opn_S==true)              //  .  +
        {                                       //  . Sell
        RefreshRates();                        //  
        Alert("  Sell: ",Symb,", ",Period());
        Alert("Bid=",Bid," SL=",SL," TP=",TP);
        Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP,0,0,0,Red);// Sel
        if(Ticket > 0)                        //  :)
          {
          return;                             //   start()
          }
        if(Fun_Error(GetLastError())==1)      //  
          continue;                           //  
        return;                                //   start()
        }
      break;                                    //   while
     }   
//----
   return;                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case   4: Alert("  .   ..",": ",Symb,", ",Period());
         Sleep(3000);                           //  
         return(1);                             //   
      case 128: Alert("  ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 129: Alert(" ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 130:Alert("  ..",": ",Symb,", ",Period());
         break;                             //   
      case 135:Alert(" .   ..",": ",Symb,", ",Period());
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..",": ",Symb,", ",Period());
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..",": ",Symb,", ",Period());
         Sleep(3000);                           //  
         return(1);                             //   
      case 138:Alert("  ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 145:Alert("     .   15.",": ",Symb,", ",Period());
         Cls = false;
         Sleep(15000);                        //  
         return(1);                             //   
      case 146:Alert("  .  ..",": ",Symb,", ",Period());
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .",": ",Symb,", ",Period());
         return(0);                             //   
      case  5: Alert("  .",": ",Symb,", ",Period());
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .",": ",Symb,", ",Period());
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .",": ",Symb,", ",Period());
         return(0);                             //   
      case 134:Alert("    .",": ",Symb,", ",Period());
         return(0);                             //   
      default: Alert("  ",Error,": ",Symb,", ",Period()); //     
         return(0);                             //   
     }
  }

//+------------------------------------------------------------------+
void Fun_New_Bar()                              // -   
  {                                             
   New_Bar=false;                               //   
   if(New_Time!=Time[0])                        //  
     {
      New_Time=Time[0];                         //   
      New_Bar=true;                             //     
     }
  }

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   New_Time=Time[0];                               //   
   switch(StartT)
     {                                             
     case 0: StartTime = "00:00"; break;
     case 1: StartTime = "01:00"; break;
     case 2: StartTime = "02:00"; break;
     case 3: StartTime = "03:00"; break;
     case 4: StartTime = "04:00"; break;
     case 5: StartTime = "05:00"; break;
     case 6: StartTime = "06:00"; break;
     case 7: StartTime = "07:00"; break;
     default: StartTime = "07:00"; break;
     }
   switch(FinishT)
     {                                             
     case 16: FinishTime = "16:00"; break;
     case 17: FinishTime = "17:00"; break;
     case 18: FinishTime = "18:00"; break;
     case 19: FinishTime = "19:00"; break;
     case 20: FinishTime = "20:00"; break;
     case 21: FinishTime = "21:00"; break;
     case 22: FinishTime = "22:00"; break;
     case 23: FinishTime = "23:00"; break;
     default: FinishTime = "16:00"; break;
     }

   if(useCl==1) useClose = true; else useClose = false; 
   if(Rev==1) Reverse = true; else Reverse = false; 

     //    
   bool Msg=true;
   int 
      Total,                                       //     
      Ticket,
      Tip=-1;                                      //  .  (B=0,S=1)
   double 
      TP,
      SL;

   for(int i=1; i<=OrdersTotal(); i++)             //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true)    //   
        {                                          //  :
         if (OrderSymbol()!=Symbol())continue;         //   . 
         if (OrderType()>1)                        //  
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Total++;                                  //  . 
         if (Total>1)                              //    
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Ticket =OrderTicket();                    //  . .
         Tip    =OrderType();                      //   .
         SL     =OrderStopLoss();                  // SL  .
         TP     =OrderTakeProfit();                // TP  .
        }
     }
            //      
      ObjectDelete("New_Open"); 
      ObjectDelete("New_SL"); 
     }                                                      //   

  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
      //    
   int 
      Total,                                       //     
      Tip=-1,                                      //  .  (B=0,S=1)
      Ticket;
   double 
      TP,
      SL;

   for(int i=1; i<=OrdersTotal(); i++)             //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true)    //   
        {                                          //  :
         if (OrderSymbol()!=Symbol())continue;         //   . 
         if (OrderType()>1)                        //  
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Total++;                                  //  . 
         if (Total>1)                              //    
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Ticket =OrderTicket();                    //  . .
         Tip    =OrderType();                      //   .
         SL     =OrderStopLoss();                  // SL  .
        }
     }
   ObjectDelete("New_Open"); 
   ObjectDelete("New_SL"); 
   return(0);
  }


